# Concerns (questions) with the current implementaion

## Can `WeakFunctor` be an associated type of a `Functor` instead of its supertype?

## `Clone`-`FnMut` category functors

## `Copy`-`Fn` category functors

## `WeakFunctor::F<'a, A>` is not (yet) covariant over the lifetime `'a`.

### Specific case: `Stackless<'a>` isn't covariant.
Current hypothesis is that this comes from `EvalTree<'a>` being invariant over `'a`
due to `FnOnce` being invariant over its output,
which in turn comes from present typesysten limitations.

## It might be better to have a per-lifetime trait for `Functor`s.

Current:
```rust
pub trait WeakFunctor {
    type F<'a, A: 'a>: 'a
    where
        Self: 'a;
}
```

Proposed:
```rust
pub trait WeakFunctor<'a>: 'a {
    type F<A: 'a>: 'a;
}
```
